package com.gic.auth.utils.resourcegroup;

import com.gic.auth.constant.ResourceHoldEnum;
import com.gic.auth.dto.StoreOrderResourceDTO;
import com.gic.auth.dto.StoreResourceDTO;
import com.gic.auth.entity.TabSysResourceGroup;

import java.util.Collections;

/**
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/8/9 11:03 AM 
 */
public class StoreOrderResourceData implements IResourceGroupData{
    @Override
    public <T> T getResourceData(TabSysResourceGroup resourceGroup) {
        StoreOrderResourceDTO data = new StoreOrderResourceDTO();
        boolean isAll = resourceGroup.getStoreOrderArea() == 2;
        if (isAll) {
            data.setType(ResourceHoldEnum.ALL.getCode());
            return (T) data;
        }
        data.setType(ResourceHoldEnum.DART.getCode());
        StoreResourceDTO storeResourceDTO = new StoreResourceData().getResourceData(resourceGroup);
        data.setStoreIdList(storeResourceDTO.getStoreIdList());
        return (T) data;
    }

    @Override
    public <T> T getResourceDataForAdmin() {
        StoreOrderResourceDTO data = new StoreOrderResourceDTO();
        data.setType(ResourceHoldEnum.ALL.getCode());
        return (T) data;
    }

    @Override
    public <T> T getResourceDataWhenNoExist() {
        StoreOrderResourceDTO data = new StoreOrderResourceDTO();
        data.setType(ResourceHoldEnum.DART.getCode());
        data.setStoreIdList(Collections.emptyList());
        return (T) data;
    }
}
